diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 794f9735e..6ad285d9e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -21,15 +21,19 @@ import net.minecraft.client.gui.hud.HudIngameDoom;
 import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.CullFace;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.Version;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.util.glu.GLU;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.options.ScreenOptions;
@@ -39,41 +43,41 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
-public class ScreenMainMenu extends Screen
-{
+public class ScreenMainMenu extends Screen {
     private static final Logger LOGGER = LogUtils.getLogger();
 
     private static final Block<?>[] BLOCKS_TO_DRAW = {
-    		Blocks.STONE, Blocks.DIRT, Blocks.PLANKS_OAK, Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY, Blocks.BASALT, Blocks.LIMESTONE,
-    		Blocks.GRANITE, Blocks.BRICK_CLAY, Blocks.ICE, Blocks.WOOL, Blocks.BLOCK_SNOW, Blocks.OBSIDIAN, Blocks.COBBLE_NETHERRACK
+        Blocks.STONE, Blocks.DIRT, Blocks.PLANKS_OAK, Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY, Blocks.BASALT, Blocks.LIMESTONE,
+        Blocks.GRANITE, Blocks.BRICK_CLAY, Blocks.ICE, Blocks.WOOL, Blocks.BLOCK_SNOW, Blocks.OBSIDIAN, Blocks.COBBLE_NETHERRACK
     };
     private static String[] logoBlockLayers = null;
-    
+
     private static final int[] KEY_CHAIN = {
-            Keyboard.KEY_I, Keyboard.KEY_D, Keyboard.KEY_S, Keyboard.KEY_P, Keyboard.KEY_I, Keyboard.KEY_S,
-            Keyboard.KEY_P, Keyboard.KEY_O, Keyboard.KEY_P, Keyboard.KEY_D, Keyboard.KEY_RETURN
+        Keyboard.KEY_I, Keyboard.KEY_D, Keyboard.KEY_S, Keyboard.KEY_P, Keyboard.KEY_I, Keyboard.KEY_S,
+        Keyboard.KEY_P, Keyboard.KEY_O, Keyboard.KEY_P, Keyboard.KEY_D, Keyboard.KEY_RETURN
     };
-    
+
     private static final Random rand = new Random();
-    
+
     private String splashText = "missingno";
     private ButtonElement multiplayerButton;
     private LogoBlock[][] logoBlocks;
-    private Snowflake[] snowflakes = new Snowflake[50];
+    private final Snowflake[] snowflakes = new Snowflake[50];
     private int logoClickCounter = 0;
     private int indexToDraw = 0;
     private int codeProgress = 0;
     private boolean showBuildTime = false;
-    private String buildTimeString = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date(Version.BUILD_TIME));
+    private final String buildTimeString = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date(Version.BUILD_TIME));
 
     static {
-    	loadLogo();
+        loadLogo();
     }
 
-	public ScreenMainMenu() {
-		ScreenPause.photoModeDisabled = false;
+    public ScreenMainMenu() {
+        ScreenPause.photoModeDisabled = false;
 
         try (InputStream stream = Minecraft.getMinecraft().texturePackList.getResourceAsStream("/assets/minecraft/textures/gui/title/splashes.txt")) {
 
@@ -94,120 +98,93 @@ public class ScreenMainMenu extends Screen
                     allSplashes.add(line);
                 }
             }
-            splashText = allSplashes.get(rand.nextInt(allSplashes.size()));
+            this.splashText = allSplashes.get(rand.nextInt(allSplashes.size()));
         } catch (Exception e) {
             LOGGER.error("Failed to load splash texts!", e);
         }
-	}
+    }
 
     @Override
-	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
-    {
-        if (eventKey == KEY_CHAIN[codeProgress])
-        {
-            codeProgress++;
-            if (codeProgress == KEY_CHAIN.length)
-            {
-                if (mc.hudIngame instanceof HudIngameDoom)
-                {
-                    mc.hudIngame = new HudIngame(mc);
-                }
-                else
-                {
-                    mc.hudIngame = new HudIngameDoom(mc);
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey == KEY_CHAIN[this.codeProgress]) {
+            this.codeProgress++;
+            if (this.codeProgress == KEY_CHAIN.length) {
+                if (this.mc.hudIngame instanceof HudIngameDoom) {
+                    this.mc.hudIngame = new HudIngame(this.mc);
+                } else {
+                    this.mc.hudIngame = new HudIngameDoom(this.mc);
                 }
-                mc.sndManager.playSound("mob.pig", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
-                codeProgress = 0;
+                this.mc.sndManager.playSound("mob.pig", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+                this.codeProgress = 0;
             }
-        }
-        else if (eventKey != -1)
-        {
-            codeProgress = 0;
+        } else if (eventKey != -1) {
+            this.codeProgress = 0;
         }
     }
 
     @Override
-	public void init()
-    {
+    public void init() {
         I18n i18n = I18n.getInstance();
 
-        for(int i = 0; i < snowflakes.length; i++){
-            snowflakes[i] = new Snowflake(rand.nextInt(width), rand.nextInt(height),1 + rand.nextInt(4), height);
+        for (int i = 0; i < this.snowflakes.length; i++) {
+            this.snowflakes[i] = new Snowflake(rand.nextInt(this.width), rand.nextInt(this.height), 1 + rand.nextInt(4), this.height);
         }
 
-        if (Holidays.ANNIVERSARY_JONKADELIC.isActive())
-        {
-            splashText = i18n.translateKey("gui.main_menu.label.splash.jonkadelic_birthday");
-        }
-        else if (Holidays.ANNIVERSARY_MAGGANDGEEZ.isActive())
-        {
-            splashText = i18n.translateKey("gui.main_menu.label.splash.maggandgeez_birthday");
-        }
-        else if (Holidays.ANNIVERSARY_MINECRAFT.isActive())
-        {
-            splashText = i18n.translateKey("gui.main_menu.label.splash.minecraft_birthday");
-        }
-        else if (Holidays.ANNIVERSARY_BTA.isActive())
-        {
-            splashText = i18n.translateKey("gui.main_menu.label.splash.bta_birthday");
-        }
-        else if (Holidays.XMAS.isActive())
-        {
-            splashText = i18n.translateKey("gui.main_menu.label.splash.xmas");
-        }
-        else if (Holidays.NEW_YEAR.isActive())
-        {
-            splashText = i18n.translateKey("gui.main_menu.label.splash.new_year");
-        }
-        else if (Holidays.HALLOWEEN.isActive())
-        {
-            splashText = i18n.translateKey("gui.main_menu.label.splash.halloween");
+        if (Holidays.ANNIVERSARY_JONKADELIC.isActive()) {
+            this.splashText = i18n.translateKey("gui.main_menu.label.splash.jonkadelic_birthday");
+        } else if (Holidays.ANNIVERSARY_MAGGANDGEEZ.isActive()) {
+            this.splashText = i18n.translateKey("gui.main_menu.label.splash.maggandgeez_birthday");
+        } else if (Holidays.ANNIVERSARY_MINECRAFT.isActive()) {
+            this.splashText = i18n.translateKey("gui.main_menu.label.splash.minecraft_birthday");
+        } else if (Holidays.ANNIVERSARY_BTA.isActive()) {
+            this.splashText = i18n.translateKey("gui.main_menu.label.splash.bta_birthday");
+        } else if (Holidays.XMAS.isActive()) {
+            this.splashText = i18n.translateKey("gui.main_menu.label.splash.xmas");
+        } else if (Holidays.NEW_YEAR.isActive()) {
+            this.splashText = i18n.translateKey("gui.main_menu.label.splash.new_year");
+        } else if (Holidays.HALLOWEEN.isActive()) {
+            this.splashText = i18n.translateKey("gui.main_menu.label.splash.halloween");
         }
 
-        int i = height / 4 + 48;
-        buttons.add(new ButtonElement(1, width / 2 - 100, i, i18n.translateKey("gui.main_menu.button.singleplayer")));
-        buttons.add(multiplayerButton = new ButtonElement(2, width / 2 - 100, i + 24, i18n.translateKey("gui.main_menu.button.multiplayer")));
-        buttons.add(new ButtonElement(3, width / 2 - 100, i + 48, i18n.translateKey("gui.main_menu.button.asset_packs")));
-        if(mc.hideQuitButton)
-        {
-            buttons.add(new ButtonElement(0, width / 2 - 100, i + 72, i18n.translateKey("gui.main_menu.button.options")));
-        } else
-        {
-            buttons.add(new ButtonElement(0, width / 2 - 100, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.options")));
-            buttons.add(new ButtonElement(4, width / 2 + 2, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.quit_game")));
+        int i = this.height / 4 + 48;
+        this.buttons.add(new ButtonElement(1, this.width / 2 - 100, i, i18n.translateKey("gui.main_menu.button.singleplayer")));
+        this.buttons.add(this.multiplayerButton = new ButtonElement(2, this.width / 2 - 100, i + 24, i18n.translateKey("gui.main_menu.button.multiplayer")));
+        this.buttons.add(new ButtonElement(3, this.width / 2 - 100, i + 48, i18n.translateKey("gui.main_menu.button.asset_packs")));
+        if (this.mc.hideQuitButton) {
+            this.buttons.add(new ButtonElement(0, this.width / 2 - 100, i + 72, i18n.translateKey("gui.main_menu.button.options")));
+        } else {
+            this.buttons.add(new ButtonElement(0, this.width / 2 - 100, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.options")));
+            this.buttons.add(new ButtonElement(4, this.width / 2 + 2, i + 72 + 12, 98, 20, i18n.translateKey("gui.main_menu.button.quit_game")));
         }
         int d = 1; // Move away from the edge of the screen to prevent unintentional activation because the cursor defaults to 0, 0
-        buttons.add(new ClickableLabelElement(5, d, height - 48 - d, i18n.translateKey("gui.main_menu.button.credits"), 0xFF9F9F9F, "minecraft:gui/screen/main_menu/icon_credits"));
-        buttons.add(new ClickableLabelElement(6, d, height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0xFF5AA938, "minecraft:gui/screen/main_menu/icon_website"));
-        buttons.add(new ClickableLabelElement(7, d, height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0xFF5865F2, "minecraft:gui/screen/main_menu/icon_discord"));
-        buttons.add(new ClickableLabelElement(8, d, height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFFFF0000, "minecraft:gui/screen/main_menu/icon_youtube"));
-        buttons.add(new ButtonElement(9, width / 2 + 104, i + 72 + 12, 20, 20, "")
+        this.buttons.add(new ClickableLabelElement(5, d, this.height - 48 - d, i18n.translateKey("gui.main_menu.button.credits"), 0xFF9F9F9F, "minecraft:gui/screen/main_menu/icon_credits"));
+        this.buttons.add(new ClickableLabelElement(6, d, this.height - 36 - d, i18n.translateKey("gui.main_menu.button.website"), 0xFF5AA938, "minecraft:gui/screen/main_menu/icon_website"));
+        this.buttons.add(new ClickableLabelElement(7, d, this.height - 24 - d, i18n.translateKey("gui.main_menu.button.discord"), 0xFF5865F2, "minecraft:gui/screen/main_menu/icon_discord"));
+        this.buttons.add(new ClickableLabelElement(8, d, this.height - 12 - d, i18n.translateKey("gui.main_menu.button.youtube"), 0xFFFF0000, "minecraft:gui/screen/main_menu/icon_youtube"));
+        this.buttons.add(new ButtonElement(9, this.width / 2 + 104, i + 72 + 12, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_language", "minecraft:gui/misc/button_language_highlighted", "minecraft:gui/misc/button_language"));
-        ButtonElement debugButton = new ButtonElement(10, width - 8, height - 8, 8, 8, "");
+        ButtonElement debugButton = new ButtonElement(10, this.width - 8, this.height - 8, 8, 8, "");
         debugButton.visible = false;
-        buttons.add(debugButton);
-        buttons.add(new ButtonElement(11, width / 2 - 104 - 20, i + 72 + 12, 20, 20, "")
+        this.buttons.add(debugButton);
+        this.buttons.add(new ButtonElement(11, this.width / 2 - 104 - 20, i + 72 + 12, 20, 20, "")
             .setTextures("minecraft:gui/misc/button_support", "minecraft:gui/misc/button_support_highlighted", "minecraft:gui/misc/button_support"));
-        if(mc.session == null)
-        {
-            multiplayerButton.enabled = false;
+        if (this.mc.session == null) {
+            this.multiplayerButton.enabled = false;
         }
-        if (Minecraft.isMultiplayerDisabled)
-        {
-        	multiplayerButton.enabled = false;
-        	multiplayerButton.displayString = i18n.translateKey("gui.main_menu.button.multiplayer.disabled");
+        if (Minecraft.isMultiplayerDisabled) {
+            this.multiplayerButton.enabled = false;
+            this.multiplayerButton.displayString = i18n.translateKey("gui.main_menu.button.multiplayer.disabled");
         }
     }
 
     @Override
-    protected void buttonClicked(@NotNull ButtonElement button)
-    {
+    protected void buttonClicked(@NotNull ButtonElement button) {
         switch (button.id) {
             case 0:
-                mc.displayScreen(new ScreenOptions(this));
+                this.mc.displayScreen(new ScreenOptions(this));
                 break;
             case 1:
-                mc.displayScreen(new ScreenSelectWorld(this));
+                this.mc.displayScreen(new ScreenSelectWorld(this));
                 break;
             case 2:
                 boolean hasJCE;
@@ -216,20 +193,20 @@ public class ScreenMainMenu extends Screen
                 } catch (final Exception ignored) {
                     hasJCE = false;
                 }
-                if (!(hasJCE) && mc.gameSettings.doJCECheck.value) {
-                    mc.displayScreen(new ScreenMissingJCE(this, new ScreenSelectServer(this)));
+                if (!(hasJCE) && this.mc.gameSettings.doJCECheck.value) {
+                    this.mc.displayScreen(new ScreenMissingJCE(this, new ScreenSelectServer(this)));
                 } else {
-                    mc.displayScreen(new ScreenSelectServer(this));
+                    this.mc.displayScreen(new ScreenSelectServer(this));
                 }
                 break;
             case 3:
-                mc.displayScreen(new ScreenOptions(this, OptionsPages.ASSET_PACKS));
+                this.mc.displayScreen(new ScreenOptions(this, OptionsPages.ASSET_PACKS));
                 break;
             case 4:
-                mc.shutdown();
+                this.mc.shutdown();
                 break;
             case 5:
-                mc.displayScreen(new ScreenCredits(this));
+                this.mc.displayScreen(new ScreenCredits(this));
                 break;
             case 6:
                 // Website
@@ -248,32 +225,30 @@ public class ScreenMainMenu extends Screen
                 UrlHelper.openURL("https://bugs.betterthanadventure.net/");
                 break;
             case 9:
-                mc.displayScreen(new ScreenOptions(this, OptionsPages.LANGUAGE));
+                this.mc.displayScreen(new ScreenOptions(this, OptionsPages.LANGUAGE));
                 break;
             case 10:
-                mc.displayScreen(new ScreenOptions(this, OptionsPages.DEBUG));
+                this.mc.displayScreen(new ScreenOptions(this, OptionsPages.DEBUG));
                 break;
         }
     }
 
-	@Override
-	public void renderTexturedBackground() {
-		if(mc.mainMenuBackground.isEnabled() && !mc.gameSettings.alphaMenu.value) {
-			mc.mainMenuBackground.draw();
-		}else {
-			super.renderTexturedBackground();
-		}
-	}
+    @Override
+    public void renderTexturedBackground() {
+        if (this.mc.mainMenuBackground.isEnabled() && !this.mc.gameSettings.alphaMenu.value) {
+            this.mc.mainMenuBackground.draw();
+        } else {
+            super.renderTexturedBackground();
+        }
+    }
 
     @Override
-    public void tick()
-    {
-        for (Snowflake snowflake : snowflakes) {
+    public void tick() {
+        for (Snowflake snowflake : this.snowflakes) {
             snowflake.updateEffects();
         }
 
-        if(this.logoBlocks != null)
-        {
+        if (this.logoBlocks != null) {
             for (LogoBlock[] logoBlock : this.logoBlocks) {
                 for (LogoBlock block : logoBlock) {
                     block.updateLogoEffects();
